﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ACO
{
    public class ResultFound
    {
        #region fields and attributes

        public double routeLength;
        public int CyclusesNeeded;
        public TimeSpan timeNeeded;

        #endregion

        #region constructors

        /// <summary>
        /// creates a record of a new found best route, with the given optimization time, 
        /// cycle number in wivh it was found, and the route length
        /// </summary>
        /// <param name="length">route length</param>
        /// <param name="cyclus">cycle number</param>
        /// <param name="time">optimization time</param>
        public ResultFound(double length, int cyclus, TimeSpan time)
        {
            this.CyclusesNeeded = cyclus;
            this.routeLength = length;
            this.timeNeeded = time;
        }

        #endregion
    }
}
