﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleRunner
{
    class Program
    {
        static void Main(string[] args)
        {
            string problemPath= "";
            string savePath = "Data";
            int duration = 600;
            switch (args.Count())
            {
                case 0:
                    //empty program
                    return;
                case 1:
                    //problem name
                    problemPath = args[0];
                    break;
                case 2:
                    problemPath = args[0];
                    savePath = args[1];
                    break;
                default:
                    problemPath = args[0];
                    savePath = args[1];
                    duration = int.Parse(args[2]);
                    break;
            }
            ACO.AntColony.Instance.ReadProblemFromFile(problemPath);
            ACO.PheromoneType pt = new ACO.PheromoneType();
            ACO.StopConditions sc = new ACO.StopConditions(true, false, true);
            sc.optimizationTime = new TimeSpan(0,0,duration);
            ACO.AlgType at = new ACO.AlgTypeACO(true, false, true, true);
            ACO.AntColony.Instance.Start(at, pt, sc);
            ACO.SaveDataClass.Instance.SaveTableResults(savePath);
            return;
        }
    }
}
