﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WPF_Window
{
    class HelpClass
    {

        #region Properties

        private static HelpClass instance = null;

        public static HelpClass Instance
        {
            get
            {
                if (HelpClass.instance == null)
                {
                    HelpClass.instance = new HelpClass();
                }
                return HelpClass.instance;
            }
        }

        private HelpClass()
        {
        }

        #endregion

        #region HelpData- stringovi

        public string ACOAlgoritam()
        {
            string helpdata = "Mravi u Prirodi";
            helpdata += "\r\n" + "Način na koji mravi u prirodi pronalaze hranu je neko vrijeme bila nepoznanica, dok nije otkriveno da mravi kad pronađu hranu iza sebe ostavljaju trag feromona. Drugi mravi koji osjete feromone prate ih do hrane i vraćaju se do mravinjaka. Ukoliko negdje osjete jači trag feromona radije idu za njim nego za onim tragom koji je slabiji. To ima dva razloga, jedan je isparavanje feromona. Dakle što više vremena je prošlo od postavljanja feromona to je trag slabiji, što se dobro uklapa u logiku pronalaženja, jer ona hrana koja je više udaljena od mravinjaka na taj način ima manju šansu da bude praćena u odnosu na neku bližu. Drugi razlog razlike među tragovima feromona je broj mrava koji su ga postavili. Što više mrava se prethodno odlučilo za jedan put to je veća vjerojatnost da je put dobar te ga i ostali mravi prate.";
            helpdata += "\r\n" + "Ukoliko se na putu pojavi prepreka koja postojeći put dijeli na dva nejednaka puta, mravi na početku ne znaju koja strana je kraća. Stoga je vjerojatnost da će mravi krenuti na dulju i kraću stranu jednaka. Pošto je jedna strana kraća, na toj strani će trag feromona ubrzo postati jači, jer na kraćoj strani ne stigne ispariti koliko na duljoj strani. Pošto osjećaju da je trag feromona na jednoj strani jači više mrava se odlučuje za njega, te se ubrzo svi mravi odlučuju za kraći put.";
            helpdata += "\r\n" + "\r\n" + "Umjetni Mravi";
            helpdata += "\r\n" + "Neka je zadani problem TSP (traveling salesman problem). Broj gradova koje treba obići je n, m je broj mrava ukupno u sustavu.";
            helpdata += "\r\n" + "Mrav se odlučuje u koji grad j će sljedeće ići po funkciji koja kao parametre ima udaljenost gradova i trag feromona na njihovoj poveznici. Kako bi se izbjeglo obilaženje istih gradova više puta svaki mrav ima svoju tabu listu u koju stavi svaki grad koji je obišao. Kada tabu lista mrava obuhvati svih n gradova, mrav postavi feromone na svaki put kojeg je koristio za obilazak gradova te resetira svoju tabu listu.";
            helpdata += "\r\n" + "Globalno gledajući svaki mrav se u trenutku t odlučuje gdje će biti u trenutku t+1, te se pri idućoj iteraciji koraka pomiče tamo. Na taj način svi će mravi nakon n iteracija proći kroz sve gradove (trenutak t+n) i postaviti trag. Pri tome se učitaju novi podatci za feromone na način da se stara vrijednost pomnoži faktorom isparavanja rho (faktor isparavanja je zbunjujući naziv, on naime govori upravo suprotno, koliki dio traga NE isparava), te mu se nadoda trag svakog mrava koji je tuda prolazio.";
            helpdata += "\r\n" + "Količina feromona koju mrav doda na neki put je 0 ako nije prošao tim putem. Ukoliko je mrav prošao tim putem, ostavlja neki određeni iznos traga određen opcijama Tip Feromona i iznos konstante feromona.";
            helpdata += "\r\n" + "Pri odluci kamo da ide, osim traga feromona, mrav koristi i vidljivost. Vidljivost je parametar obrnut od udaljenosti. Što je grad udaljeniji to je vidljivost manja (vidljivost = 1/udaljenost).";
            helpdata += "\r\n" + "alpha i beta su parametri koji upravljaju odnos važnosti traga u odnosu na vidljivost. Što je alpha veći to će mrav svoje odluke više bazirati na tragu feromona. Što je beta veći, analogno tragu, mrav će pri donošenju odluke veću važnost pridijeliti vidljivosti gradova.";
            helpdata += "\r\n" + "Pri pokretanju programa najprije je potrebno stvoriti i postaviti gradove, te trag (trail) feromona na ceste koje ih povezuju. Zatim se stvore i postave svi mravi. Pri postavljanju mrava stvore se tabu liste, mravi se postave u početni grad (svaki mrav ima svoj početni grad, može biti i više mrava ili nijedan mrav u nekom gradu) te se taj početni grad stavi kao prvi član tabu liste.";
            helpdata += "\r\n" + "Zatim počinju iteracije kretanja mrava. Nakon n (broj gradova) iteracija svi mravi imaju pune tabu liste te se postavlja trag feromona svakog mrava. Mravi se nanovo postave u neki početni grad i tabu liste im se isprazne (odnosno ostane samo novi početni grad). Takav ciklus od n iteracija se ponavlja toliko puta dok korisnik ne prekine rad programa ili program dostigne maksimum dozvoljenih ciklusa.";
            helpdata += "\r\n" + "\r\n" + "ACO - MinMax";
            helpdata += "\r\n" + "MinMax dodatak ACO algoritmu je ideja temeljena na razlikama najboljeg i najlošijeg. Uključivanjem MinMax opcije se na kraju svakog ciklusa izabire gornja granica i donja granica feromona, te se sve vrijednosti feromona izvan tih granica vraćaju na max ili min vrijednost (ovisno dali je vrijednost bila pre velika ili premala).";
            helpdata += "\r\n" + "\r\n" + "ACO - Foot Stepping";
            helpdata += "\r\n" + "Foot Stepping algoritam je dodatak ACO algoritmu koji ubrzava pronalaženje dobrih rješenja u koloniji, no isto tako i pospješuje zapinjanje u lokalnim minimumima.";
            helpdata += "\r\n" + "\r\n" + "ACO - System";
            helpdata += "\r\n" + "System dodatak aco algoritmu određuje početni iznos feromona na svim stazama u problemu. Odlično se slaže u kombinaciji sa minmax algoritmom koji ravna loše strane ovakvog pristupa.";
            helpdata += "\r\n" + "\r\n" + "ACO - Elitism";
            helpdata += "\r\n" + "Elitism ideja se zasniva na evolucijskoj teoriji opstanka najboljeg. Naime primjenjujući elitizam samo najbolji mrav u ciklusu postavlja svoj puni trag feromona, a svi ostali mravi postavljaju samo dio feromona kojeg bi inače postavili. Što slabiji rezultat mrava, to će manje feromona doprinijeti.";
            helpdata += "\r\n" + "\r\n" + "Greedy";
            helpdata += "\r\n" + "Pohlepni algoritam je vrlo primitivan algoritam, koji daje za neke probleme optimalno riješenje vrlo brzo, no za slučajne i \"razbacane\" probleme daje mnogo lošije rezultate od ACO algoritama. Prednost greedy algoritma je što su mu dovoljna 2 ili 3 ciklusa da pronađe najbolje rješenje koje se može naći greedy algoritmom (jako je brz).";
            return helpdata;
        }

        public string ACOParameters()
        {
            string helpdata = "Parametri Optimizacije";
            helpdata += "\r\n" + "\r\n" + "Broj vozila: označuje broj agenata za obilazak lokacija. Koristi se samo u VRP-u, ujedno je i jedina razlika između implementiranih TSP i VRP optimizacijskih problema. Preporučen broj vozila razlikuje se od problema do problema (primjerice 3 za 3 koncentrična kruga).";
            helpdata += "\r\n" + "\r\n" + "Broj mrava (m): Daje mogućnost odabira koliko će agenata sudjelovati u optimizaciji. Veći broj generalno daje bolje rezultate optimizacije, ali i povećava trajanje optimizacije. Preporučen broj mrava je da bude okvirno blizak broju lokacija (gradova) u problemu.";
            helpdata += "\r\n" + "\r\n" + "Parametar važnosti traga feromona (alpha): Odabire koliku važnost će trag feromona imati u funkciji izbora sljedećeg koraka pojedinih mrava. Preporučen iznos alphe je [0,8; 1,8]; najbolja rješenja zabilježena su sa alpha [1; 1,3].";
            helpdata += "\r\n" + "\r\n" + "Parametar važnosti vidljivosti (beta): Odabire koliku važnost će vidljivost imati u funkciji izbora sljedećeg koraka pojedinih mrava. Preporučen iznos beta je između 1 i 5, uz uži izbor između 1,5 i 3.";
            helpdata += "\r\n" + "\r\n" + "Faktor (ne)isparavanja (rho): Faktor kojim se množi cijela matrica feromona nakon svakog ciklusa, dočarava isparavanje feromona u prirodi. Najbolji rezultati zabilježeni su pri 0,45<rho<0,75.";
            helpdata += "\r\n" + "\r\n" + "Broj Ciklusa (NC - Number of Cycles): Broj ciklusa u koliko će kolonija pokušati pronaći bolje rješenje za zadani problem. Veći broj ciklusa daje više mogućnosti pronalaska boljeg rješenja, no optimizacija traje dulje. Preporučen broj ciklusa varira za 2 reda veličine, ovisno o iznosu alphe, broju gradova u problemu i broju mrava u koloniji. Za Greedy algoritam preporučen broj ciklusa je 1-3, jer se ne bazira na vjerojatnosti i slučajnosti, već će svaki put mravi odabrati isti put (jedino što varira je početni grad).";
            helpdata += "\r\n" + "\r\n" + "Konstanta feromona (const): iznos feromona na svakom putu na početku optimizacije, te utječe na iznos feromona dodan na put. Preporučena konstanta je reda veličine 10.";
            helpdata += "\r\n" + "\r\n" + "Vrsta algoritma: Odabire varijantu optimizacijskog algoritma. Dane mogućnosti su ACO-standard, ACO-minmax, ACO-FootStepping, ACO-system, ACO-Elitism, te Greedy algoritam.";
            helpdata += "\r\n" + "\r\n" + "Vrsta feromona: Odabire formulu za izračun feromona kojeg svaki mrav nanosi na puteve kojima je prošao. Preporučena je linearna formula, ovisna o duljini pronađenog puta (Length).";
            return helpdata;
        }

        public string OptimizacijskiProblemi()
        {
            string helpdata = "Problem Trgovačkog Putnika";
            helpdata += "\r\n" + "Problem putnika, odnosno putujućeg prodavača, je naziv za specifičnu vrstu optimizacijskog problema. Problem je zadan na sljedeći način:";
            helpdata += "\r\n" + "Jedan prodavač mora obići sve gradove koji su mu zadani, no u svaki grad smije ući samo jednom. Kojim putem, odnosno redoslijedom je najbolje obilaziti gradove, ako su udaljenosti među gradovima različite?";
            helpdata += "\r\n" + "Prikazano formulom ovaj se zadatak može postaviti kao traženje minimuma ukupnog puta.";
            helpdata += "\r\n" + "Gradovi su zadani kao točke u ravnini, međusobno udaljene neki konstantan iznos. Naravno genetski algoritmi se neće primjenjivati na ovako bizarno jednostavne zadatke kada su samo četiri grada u pitanju, već za probleme kada je u pitanju više stotina ili tisuća gradova.";
            helpdata += "\r\n" + "Složenost ovog problema je 1/2*((n-1)!) . To znači da će za ova četiri grada postojati svega tri moguća rješenja, od kojih je lako izabrati najbolje, no već za pet gradova tu je 12 mogućih rješenja. Broj mogućnosti raste strahovito brzo i tako nadilazi sposobnosti determinističkih algoritama za velike brojeve gradova. Primjerice za 50 gradova bi broj mogućnosti koje deterministički stroj mora proći bio 3×1064.";
            helpdata += "\r\n" + "\r\n" + "Problem Usmjeravanja vozila";
            helpdata += "\r\n" + "Problem usmjeravanja vozila sličnog je porijekla kao problem putujućeg prodavača. Radi se o skupu vozila koja moraju poslužiti klijente. Problem usmjeravanja vozila poznat je diljem svijeta i često se mora rješavati, primjerice službe isporuke i dostave kao što su pošta, picerije, ispunjavanje popisa stanovništva. Potrebno je organizirati isporuke više dostavljača kako bi se povećala ušteda goriva i vremena. Bez dodatnih uvjeta, i uz broj vozila 1, vehicle routing problem odgovara travelling salesman problemu. Postoje mnoge varijacije problema usmjeravanja vozila koje lagano mijenjaju problem, a većina ih potječe iz konkretnih primjera u svijetu.";
            helpdata += "\r\n" + "Tako primjerice postoji Pickup and Delivery verzija vehicle routing problema. Pickup and delivery razlikuje se od osnovnog problema po tome što agenti (dostavljači) ne kreću iz baze s robom za isporuku, već moraju najprije pokupiti određenu robu s nekog mjesta te ju dostaviti na neko drugo mjesto. Ovaj problem može se lako još dodatno zakomplicirati dodajući u njega uvjet LIFO (Last In First Out). Pozadina ovog uvjeta je također simulirana iz svijeta, naime najlakše je dostaviti (izvaditi) robu koja je na vrhu, odnosno koja je zadnja ubačena u vozilo. ";
            helpdata += "\r\n" + "Postoje mnogi drugi uvjeti koji se mogu nadodati na bilo koju verziju problema usmjeravanja vozila, primjerice ograničenje kapaciteta vozila. Ukoliko ograničimo kapacitet vozila moramo i definirati veličinu pojedinih paketa koje je potrebno isporučiti. Uvijek se može nadodati nekakav uvjet koji će zakomplicirati rješenje problema, primjerice određeni period u danu kada dostava mora biti obavljena na pojedinim lokacijama.";
            helpdata += "\r\n" + "Radi jednostavnosti prikaza i demonstracije algoritma, u ovom programu nema dodatnih opcija VRP-a (osim broja vozila).";
            return helpdata;
        }

        public string KontrolniMeni()
        {
            string helpdata = "Kontrolni meni";
            helpdata += "\r\n" + "Na lijevom dijelu korisničkog prostora nazazi se kontrolni meni za općenito upravljanje programom.";
            helpdata += "\r\n" + "\r\n" + "Osnovne mogućnosti kontrolnog menija su mijenjanje svih pojedinih parametara optimizacije: broj vozila, broj mrava, alpha, beta, rho, konstanta feromona, uvjeti zaustavljanja, vrsta algoritma koji se koristi, te vrsta formule za dodavanje feromona.";
            helpdata += "\r\n" + "\r\n" + "Korištenjem gumba desnom sgtupcu menija moguće je pokretati optimizaciju (Start), pokrenuti optimizaciju duljine 1 ciklus (Step) ili resetirati trenutne vrijednosti optimizacije i vratiti brojač ciklusa na 0.";
            helpdata += "\r\n" + "\r\n" + "Gumb Clean briše sve gradove iz trenutno učitanog problema (time automatski i resetira koloniju). Gumbom Generate otvara se prozor sa automatizirano stvaranje problema. Također je moguće problem zapisati u datoteku, ili pročitati iz datoteke.";
            helpdata += "\r\n" + "\r\n" + "Display options nude opcije izbora što će se sve prikazati na mapi gradova i grafu rezultata.";
            return helpdata;
        }

        public string RezultatiMeni()
        {
            string helpdata = "Rezultatni meni";
            helpdata += "\r\n" + "U rezultatnom meniju (desno od mape gradova) ispisuju se rezultati optimizacije, broj gradova i vrsta trenutnog optimizacijskog problema.";
            helpdata += "\r\n" + "\r\n" + "Broj ciklusa pokazuje koliko je ciklusa kolonija odvrtila u optimizaciji.";
            helpdata += "\r\n" + "\r\n" + "Time prikazuje koliko je dugo trajala zadnja pokrenuta optimizacija u obliku [sati:minute:sekunde].";
            helpdata += "\r\n" + "\r\n" + "Best Route length prikazuje duljinu najbolje dosad pronađene rute.";
            helpdata += "\r\n" + "\r\n" + "Best Found At je redni broj ciklusa u kojem je pronađena najbolja ruta. Ukoliko je vrijednost stalno mnogo manja od ukupnog broja ciklusa, preporučljivo je smanjiti maksimalni broj ciklusa radi uštede vremena (što se više ciklusa odradi smanjuje se vjerojatnost pronalaska nove najbolje rute).";
            helpdata += "\r\n" + "\r\n" + "Broj Gradova govori koliko je gradova u trenutno aktivnom problemu. Budući da složenost algoritma ovisi o kvadratu broja gradova u problemu, preporučljivo je za demonstracijske optimizacije koristiti probleme u kojima je 50<N<120 gradova.";
            helpdata += "\r\n" + "\r\n" + "Tip problema prikazuje vrstu učitanog problema. Mogu biti TSP ili VRP (više detalja pod Optimizacijski problemi), te je moguće lako mijenjanje među tim tim problemima gumbom Change.";
            return helpdata;
        }

        public string MapaLokacija()
        {
            string helpdata = "Mapa";
            helpdata += "\r\n" + "Mapa lokacija ima više uloga u programu SL ACO:";
            helpdata += "\r\n" + "\r\n" + "1: prikaz optimizacijskog problema: pored mape moguće je uključiti/isključiti opcije crtanja gradova, najbolje rute i traga feromona. Ukoliko omogućeno, na mapi se iscrtavaju svi gradovi iz problema. U slučaju VRP-a početni grad je prvi grad u listi te je on drugačije nacrtan.";
            helpdata += "\r\n" + "\r\n" + "2: stvaranje optimizacijskog problema: svakim klikom miša na mapu dodaje se jedan grad u optimizacijski problem. Moguće je dodavati gradove na već postojeće probleme ili stvoriti novi problem iz \"praznog lista\".";
            helpdata += "\r\n" + "\r\n" + "3: Prikaz najbolje rute: ako je omogućeno crtanje najbolje rute, će se pri svakom pokretanju optimizacije na mapi istcrtati najbolja pronađena ruta. U slučaju VRP-a najbolja ruta se prikazuje u više boja radi lakšeg čitanja rezultata.";
            helpdata += "\r\n" + "\r\n" + "4: Prikaz traga feromona: Najsloženiji dio prikaza rezultata (a time i najsporiji) je prikaz traga feromona. Ukoliko je omogućen prikaz feromona, on će se iscrtavati na mapi na svakom putu koji povezuje dva grada. Intenzitet boje linije označuje količinu feromona na toj stazi, vidljivije linije imaju više feromona na sebi.";
            return helpdata;
        }

        public string GenetskiGraf()
        {
            string helpdata = "Graf";
            helpdata += "\r\n" + "Genetski graf je mogućnost SL ACO da prikaže međurezultate u vremenu, a da se nemora pokretati step funkcijom.";
            helpdata += "\r\n" + "Za iscrtavanje na grafu postoje 3 opcije, od kojih je svaka neovisna o ostale dve. Te opcije su: Duljina najbolje rute, Genetska i prosječna.";
            helpdata += "\r\n" + "\r\n" + "Opcija Optimum iscrtava vodoravnu plavu liniju na visini koja predstavlja najbolju dosad pronađenu rutu u koloniji.";
            helpdata += "\r\n" + "\r\n" + "Opcija Best Found iscrtava crvenom bojom prikaz najbolje rute pronađene do nekog trenutka. Na x-osi je brojač ciklusa (vrijeme), a na y-osi duljina rute.";
            helpdata += "\r\n" + "\r\n" + "Opcija Average crta zelenom bojom prosječnu duljinu svih pronađenih ruta u pojedinom ciklusu na istoj skali kao i genetska linija.";
            return helpdata;
        }

        public string OtvaranjeProblema()
        {
            string helpdata = "Učitavanje optimizacijskog problema";
            helpdata += "\r\n" + "\r\n" + "Gumbom Load Problem moguće je učitati optimizacijski problem iz .txt datoteke sa lokalnog računala. Pravila za zapis problema su:";
            helpdata += "\r\n" + "\r\n" + "U prvom redu MORA pisati tip problema, program SL ACO podržava TSP i VRP probleme.";
            helpdata += "\r\n" + "Svi prazni redovi, i redovi koji počinju znakom #, su komentari te ih program preskače.";
            helpdata += "\r\n" + "Svi redovi koji počinju znakom ! su preporučeni iznosi parametra. Primjerice, na taj način moguće je specifičnom VRP-u pridružiti broj vozila koji najbolje opisuje problem (3 koncentrična kruga -> 3 agenta).";
            helpdata += "\r\n" + "Svi ostali redovi (koji nisu prvi red, prazni ili da počinju sa # ili !) smatraju se definicijom grada/lokacije u obliku 2 float broja (npr:0,35234 26,324) odvojena razmakom.";
            helpdata += "\r\n" + "\r\n" + "Osim iz datoteke program SL ACO može sam stvoriti optimizacijski problem na 3 načina:";
            helpdata += "\r\n" + "Slučajan problem opcijom Random. Koordinate gradova su tada između 0 i 1.";
            helpdata += "\r\n" + "Jedan od algoritamski generiranih problema (krugovi, mreža ili slova ACO)";
            helpdata += "\r\n" + "Ručnim dodavanjem gradova u problem, svaki klik mišem na mapu gradova dodaje jednu lokaciju (grad) u problem (gumbom clean postavlja se prazna mapa sa koordinatama između 0 i 1).";
            return helpdata;
        }

        public string SpremanjeProblema()
        {
            string helpdata = "Spremanje učitanog optimizacijskog problema";
            helpdata += "\r\n" + "Gumb Save Problem sprema trenutno učitani optimizacijski problem u .txt datoteku.";
            helpdata += "\r\n" + "Oblik zapisa datoteke je takav da ga program zna nazad učitati, preporučeno je ručno dodavanje komentara u spremljen problem, radi definicije korištenja i svrhe spremljenog problema.";
            return helpdata;
        }

        public string SerijaOptimizacije()
        {
            string helpdata = "Serija";
            helpdata += "\r\n" + "Serija optimizacija je funkcija programa SL ACO da samostalno pokrene više optimizacija za redom, zapiše rezultate svake od njih i mijenja određeni parametar pri svakom novom pokretanju.";
            helpdata += "\r\n" + "Kontrole omogućene nad serijom optimizacija su:";
            helpdata += "\r\n" + "\r\n" + "Parametar - izbor koji parametar će se mijenjati među pozivima u seriji";
            helpdata += "\r\n" + "\r\n" + "Parametar minimum - početna vrijednost parametra u seriji (iznos tog parametra u prvoj optimizaciji iz serije)";
            helpdata += "\r\n" + "\r\n" + "Parametar maximum - maksimalna vrijednost parametra za koju će se još pokrenuti optimizacija u seriji";
            helpdata += "\r\n" + "\r\n" + "Step - iznos koraka koji se nadodaje na testirani parametar između svakog pokretanja optimizacije, ukoliko je manji ili jednak 0 serija se neće pokrenuti";
            helpdata += "\r\n" + "\r\n" + "Stop Conditions - Određuje uvjete zaustavljanja algoritma. moguće je odrediti uvjete zaustavljanja pojedinih optimizacija, te vremenski uvjet nad cijelom serijom optimizacija.";
            helpdata += "\r\n" + "\r\n" + "Nakon svake pojedine optimizacije u seriji poziva se spremanje rezultata optimizacije.";
            return helpdata;
        }

        public string SpremanjeRezultata()
        {
            string helpdata = "Spremanje rezultata";
            helpdata += "\r\n" + "Rezultati optimizacije mogu se pohraniti pritiskom gumba Save Single Results. Format zapisa je jedan od 2 moguća načina: u tabličnom obliku, ili čitljivom.";
            helpdata += "\r\n" + "Ime datoteke je ono zadano u polju Output File Name sa nastavkom txt. Ukoliko već postoji datoteka sa zadanim imenom, informacije optimizacije će se samo nadodati na kraj postojeće datoteke.";
            helpdata += "\r\n" + "Čitljiv obika služi za kratke zapise koje korisnik želi brzo pregledati, dok je tablični zapis prilagođen učitavanju u microsoft Excel. Pri otvaranju .txt datoteke Excelom potrebno je navesti automatsko odvajanje stupaca znakom točkazarez ( ; ).";
            helpdata += "\r\n" + "\r\n" + "Lokacija datoteke rezultata je ista kao i pri zapisivanju optimizacijskog problema: c:\\Documents and Settings\\ImeKorisnika\\Local Settings\\Application Data\\Microsoft\\Silverlight\\is\\...\\[s]\\...\\[f]\\ImeDatoteke.txt";
            return helpdata;
        }

        #endregion


    }
}
